<?php
/* THE CROSS RADIO PROGRAMMING SCRIPT
 * Pacific Missionary Aviation, http://www.pmapacific.org
 *
 * This script produces TuneTracker Master Logs
 * 
 * Programmed by Roland Weibel, 2007-2008
 * Version 1.8, Last update: 2008-02-23
 */

function makeMyWeekday($targetDate, $targetWeekday) {
  global $lineBr;
  global $voiceRoot;
  $out = "";
  
  //Hour 00:00 - Hour 05:00
  $out .= makeMyPlainHour(        0, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        1, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        2, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        3, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        4, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        5, "NIT", $targetWeekday).$lineBr;
  
  //                                                        PROG1NAME (main program on the top of the hour, needs to be spelled exactly the same as the folder name in the program folder)
  //                                                        |                        PROG1TARGET (type: $targetDate ->for dated programs or "PICKRANDOM" ->for randomly picked programs)
  //                                                        |                        |                        SEGPR (type: true ->for segmented programs, e.g. Adventures In Odyssey, Focus On The Family Weekend)
  //                                                        |                        |                        |      FORCE (type: true ->if the day of the week has to match when scheduling old programs, for instance; if a program was made for a Monday it has to play on a Monday. If it doesn't matter, type: false)
  //                                                        |                        |                        |      |      INCR (type: true ->if this program will NOT BE REPEATED and should be incremented/advanced to the next file available next time scheduled. Type: false -> if the very same file will be repeated later)
  //                                                        |                        |                        |      |      |
  //                                                        |                        |                        |      |      |      PROG2NAME                     PROG2TARGET   FORCE  INCR   PROG3NAME                        PROG3TARGET   FORCE  INCR
  $out .= makeMyProgramHour(      6, "STD", $targetWeekday, "Walk In The Word",      $targetDate,             false, true,  false, "Listen To The Bible 1 Min",  "PICKRANDOM", false, true,  "Upwords",                       "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyClipHour(         7, "STD", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         8, "STD", $targetWeekday, "Fast").$lineBr;
  $out .= makeMyProgramHour(      9, "STD", $targetWeekday, "The Connection",        $targetDate,             false, true,  true,  "A Time For Harvest",         "PICKRANDOM", false, true,  "Route 66",                      "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     10, "STD", $targetWeekday, "Bible Answer Man",      $targetDate,             false, false, true,  "",                           "PICKRANDOM", false, true,  "",                              "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     11, "STD", $targetWeekday, "A New Beginning",       $targetDate,             false, true,  false, "Portraits Of Grace",         "PICKRANDOM", false, true,  "Hot Spots",                     "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     12, "STD", $targetWeekday, "Insight For Living",    $targetDate,             false, true,  false, "Guidelines",                 $targetDate,  true,  true,  "James Dobson Family Minute",    "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     13, "STD", $targetWeekday, "Family Life Today",     $targetDate,             false, true,  true,  "The Edge",                   "PICKRANDOM", false, true,  "Encouraging Words",             "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     14, "STD", $targetWeekday, "Focus On The Family",   $targetDate,             false, true,  true,  "The Point",                  "PICKRANDOM", false, true,  "Upwords",                       "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     15, "STD", $targetWeekday, "A New Beginning",       $targetDate,             false, true,  true,  "Portraits Of Grace",         "PICKRANDOM", false, true,  "Route 66",                      "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     16, "STD", $targetWeekday, "Adventures In Odyssey", $targetDate,             true,  false, true,  "",                           "PICKRANDOM", false, true,  "Keys For Kids",                 $targetDate,  true,  true).$lineBr;
  $out .= makeMyProgramHour(     17, "FST", $targetWeekday, "Insight For Living",    $targetDate,             false, true,  true,  "Breakpoint",                 $targetDate,  true,  true,  "Life Issues",                   "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     18, "FST", $targetWeekday, "Living On The Edge",    $targetDate,             false, true,  true,  "A Time For Harvest",         "PICKRANDOM", false, true,  "Hot Spots",                     "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     19, "STD", $targetWeekday, "Turning Point",         $targetDate,             false, true,  true,  "Upwords",                    "PICKRANDOM", false, true,  "A Woman After God's Own Heart", "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     20, "STD", $targetWeekday, "Walk In The Word",      $targetDate,             false, true,  true,  "Portraits Of Grace",         "PICKRANDOM", false, true,  "Route 66",                      "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     21, "STD", $targetWeekday, "Grace To You",          $targetDate,             false, true,  true,  "The Edge",                   "PICKRANDOM", false, true,  "Upwords",                       "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyPMFMessageWDHour(22, "STD", $targetWeekday, lastSunday($targetDate)).$lineBr;
  $out .= makeMyClipHour(        23, "NIT", $targetWeekday, "Slow").$lineBr;
  return $out;
}


function makeMySaturday($targetDate, $targetWeekday) {
  global $lineBr;
  global $voiceRoot;
  global $programRoot;
  $out = "";
  $out .= makeMyPlainHour(        0, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        1, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        2, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        3, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        4, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(        5, "NIT", $targetWeekday).$lineBr;
  $out .= makeMyClipHour(         6, "STD", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         7, "STD", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         8, "STD", $targetWeekday, "Fast").$lineBr;
  $out .= makeMyClipHour(         9, "STD", $targetWeekday, "Fast").$lineBr;
  $out .= makeMyClipHour(        10, "STD", $targetWeekday, "Fast").$lineBr;
  
  //                                                        PROG1NAME (main program on the top of the hour, needs to be spelled exactly the same as the folder name in the program folder)
  //                                                        |                              PROG1TARGET (type: $targetDate ->for dated programs or "PICKRANDOM" ->for randomly picked programs)
  //                                                        |                              |                        SEGPR (type: true ->for segmented programs, e.g. Adventures In Odyssey, Focus On The Family Weekend)
  //                                                        |                              |                        |      FORCE (type: true ->if the day of the week has to match when scheduling old programs, for instance; if a program was made for a Monday it has to play on a Monday. If it doesn't matter, type: false)
  //                                                        |                              |                        |      |      INCR (type: true ->if this program will NOT BE REPEATED and should be incremented/advanced to the next file available next time scheduled. Type: false -> if the very same file will be repeated later)
  //                                                        |                              |                        |      |      |
  //                                                        |                              |                        |      |      |      PROG2NAME                     PROG2TARGET   FORCE  INCR   PROG3NAME                        PROG3TARGET   FORCE  INCR
  $out .= makeMyProgramHour(     11, "STD", $targetWeekday, "Down Gilead Lane",            $targetDate,             false, false, true,  "Portraits Of Grace",         "PICKRANDOM", false, true,  "Hot Spots",                     "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     12, "STD", $targetWeekday, "Insight For Living Weekend",  $targetDate,             false, false, false, "Diamonds In The Dust",       "PICKRANDOM", false, true,  "James Dobson Family Minute",    "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     13, "STD", $targetWeekday, "Family Life Weekend",         $targetDate,             false, false, true,  "The Edge",                   "PICKRANDOM", false, true,  "Encouraging Words",             "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     14, "STD", $targetWeekday, "Focus On The Family Weekend", $targetDate,             true,  false, true,  "",                           "PICKRANDOM", false, true,  "Upwords",                       "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyClipHour(        15, "STD", $targetWeekday, "Fast").$lineBr;
  $out .= makeMyProgramHour(     16, "STD", $targetWeekday, "Adventures In Odyssey",       $targetDate,             true,  false, true,  "",                           "PICKRANDOM", false, true,  "Keys For Kids",                 $targetDate,  false, true).$lineBr;
  $out .= makeMyProgramHour(     17, "STD", $targetWeekday, "Breakpoint Weekend",          $targetDate,             false, false, true,  "Hot Spots",                  "PICKRANDOM", false, true,  "James Dobson Family Minute",    "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyClipHour(        18, "STD", $targetWeekday, "Fast").$lineBr;
  $out .= makeMyProgramHour(     19, "STD", $targetWeekday, "Turning Point Weekend",       $targetDate,             false, false, true,  "Upwords",                    "PICKRANDOM", false, true,  "A Woman After God's Own Heart", "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     20, "STD", $targetWeekday, "Insight For Living Weekend",  $targetDate,             false, false, true,  "Portraits Of Grace",         "PICKRANDOM", false, true,  "Route 66",                      "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     21, "STD", $targetWeekday, "Grace To You Weekend",        $targetDate,             false, false, true,  "The Edge",                   "PICKRANDOM", false, true,  "Upwords",                       "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(     22, "STD", $targetWeekday, "PMF Message",                 lastSunday($targetDate), false, true,  true,  "",                           "PICKRANDOM", false, true,  "",                              "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyClipHour(        23, "NIT", $targetWeekday, "Slow").$lineBr;
  return $out;
}


function makeMySunday($targetDate, $targetWeekday) {
  global $lineBr;
  global $voiceRoot;
  global $programRoot;
  $out = "";
  $out .= makeMyPlainHour(         0, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         1, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         2, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         3, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         4, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         5, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         6, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         7, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyPlainHour(         8, "SUM", $targetWeekday).$lineBr;
  $out .= makeMyClipHour(          9, "SUM", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         10, "SUM", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         11, "SUM", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         12, "SUM", $targetWeekday, "Slow").$lineBr;
  
  //                                                         PROG1NAME (main program on the top of the hour, needs to be spelled exactly the same as the folder name in the program folder)
  //                                                         |                                PROG1TARGET (type: $targetDate ->for dated programs or "PICKRANDOM" ->for randomly picked programs)
  //                                                         |                                |             SEGPR (type: true ->for segmented programs, e.g. Adventures In Odyssey, Focus On The Family Weekend)
  //                                                         |                                |             |      FORCE (type: true ->if the day of the week has to match when scheduling old programs, for instance; if a program was made for a Monday it has to play on a Monday. If it doesn't matter, type: false)
  //                                                         |                                |             |      |      INCR (type: true ->if this program will NOT BE REPEATED and should be incremented/advanced to the next file available next time scheduled. Type: false -> if the very same file will be repeated later)
  //                                                         |                                |             |      |      |
  //                                                         |                                |             |      |      |      PROG2NAME                     PROG2TARGET   FORCE  INCR   PROG3NAME                        PROG3TARGET   FORCE  INCR
  $out .= makeMyPMFMessageSunHour(13, "SUA", $targetWeekday, $targetDate).$lineBr;
  $out .= makeMyProgramHour(      14, "SUA", $targetWeekday, "Focus On The Family Interview", $targetDate,  false, false, true,  "",                           "PICKRANDOM", false, true,  "Upwords",                       "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyClipHour(         15, "SUA", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         16, "SUA", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyClipHour(         17, "SUA", $targetWeekday, "Slow").$lineBr;
  $out .= makeMyPMFMessageSunHour(18, "SUA", $targetWeekday, $targetDate).$lineBr;
  $out .= makeMyProgramHour(      19, "SUA", $targetWeekday, "",                              "PICKRANDOM", false, false, true,  "Upwords",                    "PICKRANDOM", false, true,  "A Woman After God's Own Heart", "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(      20, "SUA", $targetWeekday, "Hour Of Decision",              $targetDate,  false, false, true,  "Portraits Of Grace",         "PICKRANDOM", false, true,  "Route 66",                      "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyProgramHour(      21, "SUA", $targetWeekday, "",                              "PICKRANDOM", false, false, true,  "The Edge",                   "PICKRANDOM", false, true,  "Upwords",                       "PICKRANDOM", false, true).$lineBr;
  $out .= makeMyPMFMessageSunHour(22, "SUA", $targetWeekday, $targetDate).$lineBr;
  $out .= makeMyClipHour(         23, "SUA", $targetWeekday, "Slow").$lineBr;
  return $out;
}


function pickFastClip() {
  $arrSP = array();
  
  //Edit the list of fast clips (used to make "Clip Hours (Fast)"
  //The number specified the likeliness of a program being picked, for instance:
  //A program with the number 2 is twice as likely to be picked as a program with the number 1.
  //A program with the number 0 will never be picked.
  arrayMultiPush($arrSP, 2, "A Time For Harvest");
  arrayMultiPush($arrSP, 1, "A Quick Word");
  arrayMultiPush($arrSP, 1, "Discover God");
  arrayMultiPush($arrSP, 1, "Hot Spots");
  arrayMultiPush($arrSP, 1, "Life Issues");
  arrayMultiPush($arrSP, 2, "Route 66");
  arrayMultiPush($arrSP, 1, "The Edge");
  arrayMultiPush($arrSP, 1, "The Point");
  
  //srand() not needed as of PHP 4.2.0, but BeOS runs an older version
  srand((float) microtime() * 10000000);
  $randomKey = array_rand($arrSP);
  return $arrSP[$randomKey];
}


function pickSlowClip() {
  $arrSP = array();
  
  //Edit the list of slow clips (used to make "Clip Hours (Slow)"
  //The number specified the likeliness of a program being picked, for instance:
  //A program with the number 2 is twice as likely to be picked as a program with the number 1.
  //A program with the number 0 will never be picked.
  arrayMultiPush($arrSP, 1, "A Woman After God's Own Heart");
  arrayMultiPush($arrSP, 1, "Diamonds In The Dust");
  arrayMultiPush($arrSP, 1, "Encouraging Words");
  arrayMultiPush($arrSP, 1, "Insights Short Features");
  arrayMultiPush($arrSP, 2, "James Dobson Family Minute");
  arrayMultiPush($arrSP, 1, "Listen To The Bible 1 Min");
  arrayMultiPush($arrSP, 1, "Listen To The Bible 3 Min");
  arrayMultiPush($arrSP, 3, "Portraits Of Grace");
  arrayMultiPush($arrSP, 1, "Precepts From God's Word");
  arrayMultiPush($arrSP, 3, "Upwords");
  
  //srand() not needed as of PHP 4.2.0, but BeOS runs an older version
  srand((float) microtime() * 10000000);
  $randomKey = array_rand($arrSP);
  return $arrSP[$randomKey];
}


/* This function specifies different music types for different days of the week or hours
 */
function makeMusic($numberOfSongs, $type) {
  global $lineBr;
  
  //Sunday Morning
  $arrSUM = array();
  arrayMultiPush($arrSUM, 4, "Genre *Worship Tempo Slow");
  arrayMultiPush($arrSUM, 2, "Genre \"Christian Hymn\"");
  arrayMultiPush($arrSUM, 1, "Genre \"Christian Acapella\"");
  arrayMultiPush($arrSUM, 0, "Comment Christmas"); //to be set to 0 during non-Christmas season
  
  //Sunday Afternoon
  $arrSUA = array();
  arrayMultiPush($arrSUA, 2, "Genre *Worship Tempo Slow");
  arrayMultiPush($arrSUA, 0, "Comment Christmas"); //to be set to 0 during non-Christmas season
  
  //Worship Instrumental
  $arrWIN = array();
  arrayMultiPush($arrWIN, 1, "Comment Instrumental");
  
  //Children
  $arrCLD = array();
  arrayMultiPush($arrCLD, 1, "Genre \"Christian Children\"");
  
  //Night
  $arrNIT = array();
  arrayMultiPush($arrNIT, 2, "Genre *Worship Tempo Slow");
  arrayMultiPush($arrNIT, 3, "Genre *Worship Tempo Medium");
  arrayMultiPush($arrNIT, 1, "Genre \"Christian Acapella\"");
  arrayMultiPush($arrNIT, 1, "Genre \"Christian Hymn\"");
  arrayMultiPush($arrNIT, 0, "Comment Christmas"); //to be set to 0 during non-Christmas season
  
  //Worship Medium
  $arrWSM = array();
  arrayMultiPush($arrWSM, 1, "Genre *Worship Tempo Medium");
  arrayMultiPush($arrWSM, 0, "Comment Christmas"); //to be set to 0 during non-Christmas season
  
  //Fast
  $arrFST = array();
  arrayMultiPush($arrFST, 3, "Genre *Worship Tempo Fast");
  arrayMultiPush($arrFST, 1, "Genre \"Christian Rock\"");
  arrayMultiPush($arrFST, 1, "Genre \"Christian Rap\"");
  arrayMultiPush($arrFST, 0, "Comment Christmas"); //to be set to 0 during non-Christmas season
  
  //Standard
  $arrSTD = array();
  arrayMultiPush($arrSTD, 2, "Genre *Worship Tempo Fast");
  arrayMultiPush($arrSTD, 4, "Genre *Worship Tempo Medium");
  arrayMultiPush($arrSTD, 0, "Genre \"Christian Rock\"");
  arrayMultiPush($arrSTD, 0, "Genre \"Christian Rap\"");
  arrayMultiPush($arrSTD, 0, "Comment Christmas"); //to be set to 0 during non-Christmas season
  
  $out = "";
  for($i = 0; $i < $numberOfSongs; $i++) {
    $constraints = "";
    //srand() not needed as of PHP 4.2.0, but BeOS runs an older version
    srand((float) microtime() * 10000000);
    
    switch($type) {
      case "SUM":
        $constraints = $arrSUM[array_rand($arrSUM)];
        break;
      case "SUA":
        $constraints = $arrSUA[array_rand($arrSUA)];
        break;
      case "WIN":
        $constraints = $arrWIN[array_rand($arrWIN)];
        break;
      case "CLD":
        $constraints = $arrCLD[array_rand($arrCLD)];
        break;
      case "NIT":
        $constraints = $arrNIT[array_rand($arrNIT)];
        break;
      case "WSM":
        $constraints = $arrWSM[array_rand($arrWSM)];
        break;
      case "FST":
        $constraints = $arrFST[array_rand($arrFST)];
        break;
      default:
        $constraints = $arrSTD[array_rand($arrSTD)];
    }
    $out .= "Random ".$constraints.$lineBr;
  }
  return $out;
}










/*
 * DO NOT EDIT BELOW THIS LINE
 * (unless you are not comfortable programming PHP)
 *
 *
 *
 *
 * Disclaimer
 * Feel free to modify script and use for any purpose.
 * Contact me for questions and suggestions: http://www.rolandweibel.com
 *
 * command line parameters
 * php thecross.php -os -startDate -numberOfDays
 * 
 * FUNCTION SUMMARY
 * ================
 * 
 * FUNCTIONS AT THE TOP OF THE FILE FOR EASY REACH
 * -----------------------------------------------
 * makeMyWeekday()             EDIT AT WILL
 * makeMySaturday()            EDIT AT WILL
 * makeMySunday()              EDIT AT WILL
 * pickFastClip()              EDIT AT WILL
 * pickSlowClip()              EDIT AT WILL
 * makeMusic()                 EDIT AT WILL
 * 
 * SCHEDULING FUNCTIONS (DOING THE LABOR)
 * -----------------------------------------------
 * makeMySchedule()            PLEASE DO NOT TOUCH
 * makeMyProgramHour()         EDIT WITH CARE
 * makeMyClipHour()            EDIT WITH CARE
 * makeMyPlainHour()           EDIT WITH CARE
 * makeMyPMFMessageSunHour()   PLEASE DO NOT TOUCH
 * makeMyPMFMessageWDHour()    PLEASE DO NOT TOUCH
 * makeStationID()             EDIT WITH CARE
 * makePublicAnnouncements()   PLEASE DO NOT TOUCH
 * makeProgramAnnouncement()   EDIT WITH CARE
 * makeProgramIdentification() EDIT WITH CARE
 * scheduleProg()              PLEASE DO NOT TOUCH
 * 
 * SERVICE FUNCTIONS (FACILITATING TO SCHED. FUNC)
 * -----------------------------------------------
 * pickRandom()                PLEASE DO NOT TOUCH
 * filesAvailableInFolder()    PLEASE DO NOT TOUCH
 * makeTTCommands()            PLEASE DO NOT TOUCH
 * addBeApplication()          PLEASE DO NOT TOUCH
 * readProgramHistory()        PLEASE DO NOT TOUCH
 * writeProgramHistory()       PLEASE DO NOT TOUCH
 * dayOfWeekMatch()            PLEASE DO NOT TOUCH
 * addHourLeadingZero()        PLEASE DO NOT TOUCH
 * arrayMultiPush()            PLEASE DO NOT TOUCH
 * cutFileExtension()          PLEASE DO NOT TOUCH
 * logFile()                   PLEASE DO NOT TOUCH
 * logDetail()                 PLEASE DO NOT TOUCH
 * logError()                  PLEASE DO NOT TOUCH
 * logShow()                   PLEASE DO NOT TOUCH
 */

$arguments = $argv; //don't use $_SERVER to have php4 compatibility (for BeOS)
$argOS = trim($arguments[1]);
$argStartDate = trim($arguments[2]);
$argNumberOfDays = trim($arguments[3]);

$numberOfErrors = 0;

//these variables change for every target date processed
//it is needed globally for different functions to access them
$processingShowTextLog = ""; //processing TT Show Text log file (for displaying at 0600)
//targetDate is also passed down as a parameter to some functions to be more flexible
//and because PICKRANDOM is a valid targetDate
$globalTargetDate = "";

//other global variables
$interrupt_fadeout = 10;


if($argOS == "beos") {
  //BeOS mode
  $lineBr = "\n";
  $programRoot    = "/BeOS2/Programs/";
  $programHistory = "/BeOS2/Programs/_Prog_Date_History/";
  $voiceRoot      = "/boot/TheCross/Voice/";
  
  //override command line arguments (process tomorrow's programming)
  $tempDateTomorrow = getdate(mktime(0, 0, 0, date("m"), date("d") + 1, date("Y")));
  $argStartDate = date("Y-m-d", $tempDateTomorrow[0]);
  $argNumberOfDays = 1;
}
else {
  //Windows mode
  $lineBr = "\r\n";
  $programRoot    = "D:/Programs/";
  $programHistory = "D:/Programs/_Prog_Date_History/";
  $voiceRoot      = "D:/Voice/";
}

//initialize log file
$logInit = "Running in ".$argOS." mode".$lineBr;
$logInit .= "Start date: ".$argStartDate.$lineBr;
$logInit .= "Number of days: ".$argNumberOfDays.$lineBr;
$logInit .= $lineBr.$lineBr;
$myFile = "PHP_Logs/logPHP_".date("Y-m-d").".txt";
$myFileHandle = fopen($myFile, "w") or die("can't open log file to write");
fwrite($myFileHandle, $logInit);
fclose($myFileHandle);


makeMySchedule($argStartDate, $argNumberOfDays);


function makeMySchedule($startDate, $numberOfDays) {
  global $lineBr;
  global $globalTargetDate;
  global $processingShowTextLog;
  $startDateArr = explode("-", $startDate);
  
  for($i=0; $i < $numberOfDays; $i++) {
    $tempTargetDate = getdate(mktime(0, 0, 0, $startDateArr[1], $startDateArr[2] + $i, $startDateArr[0]));
    $targetDate = date("Y-m-d", $tempTargetDate[0]);
    $globalTargetDate = $targetDate;
    $targetWeekday = $tempTargetDate[weekday];
    
    //initialize showtext file
    $processingShowTextLog = "ShowText/showtext_".$targetDate.".txt";
    $showInit = "Process started: ".date("Y-m-d G:i:s").$lineBr;
    $mySTFileHandle = fopen($processingShowTextLog, "w") or die("can't open showtext file to write");
    fwrite($mySTFileHandle, $showInit);
    fclose($mySTFileHandle);
    
    //log file
    logFile("==================================================");
    logFile("Processing target date: ".$targetWeekday.", ".$targetDate);
    logShow("Processing target date: ".$targetWeekday.", ".$targetDate);
    $masterLog = "";
    switch($targetWeekday) {
      case "Saturday":
        logFile("Saturday");
        $masterLog = makeMySaturday($targetDate, $targetWeekday);
        break;
      case "Sunday":
        logFile("Sunday");
        $masterLog = makeMySunday($targetDate, $targetWeekday);
        break;
      default:
        logFile($targetWeekday);
        $masterLog = makeMyWeekday($targetDate, $targetWeekday);
    }
    //write master log to disk
    $myMaster = "TT_MasterLogs/MasterLog_".$targetDate.".txt";
    $myMasterHandle = fopen($myMaster, 'w') or die("can't open master log file to write");
    fwrite($myMasterHandle, trim($masterLog));
    fclose($myMasterHandle);
    logFile("Finished processing target date: ".$targetDate);
    logFile("");
    logFile("");
    logShow("Process ended: ".date("Y-m-d G:i:s"));
    
    global $argOS;
    if($argOS == "beos") {
      addBeApplication($targetDate, $targetWeekday);
    }
  }
  global $numberOfErrors;
  logFile("Job complete, number of errors encountered: ".$numberOfErrors);
  logShow("Number of errors: ".$numberOfErrors);
}


/* $targetDate: 2007-10-04 or PICKRANDOM
 * 
 */
function makeMyProgramHour($hour, $musicType, $weekday, $prog1Name, $prog1TargetDate, $prog1Segm, $prog1ForceDayOfWeek, $prog1Incr, $prog2Name, $prog2TargetDate, $prog2ForaceDayOfWeek, $prog2Incr, $prog3Name, $prog3TargetDate, $prog3ForaceDayOfWeek, $prog3Incr) {
  global $lineBr;
  global $voiceRoot;
  global $programRoot;
  global $interrupt_fadeout;
  $out = "";
  $out .= "# Hour ".$hour.$lineBr;
  $out .= "# interrupt@:00:00 ".$interrupt_fadeout.$lineBr;
  $out .= makeStationID($hour, $weekday, true).$lineBr;
  $out .= makePublicAnnouncements();
  $out .= makeTTCommands($hour);
  if($prog1Name == "") {
    //no main program scheduled
  }
  else {
    //main program scheduled
    if($prog1Segm) {
      //segmented
      if($prog1TargetDate == "PICKRANDOM") {
        logError("A program cannot be both segmented and picked randomly!");
      }
      else {
        $out .= "Play ".scheduleProg($prog1Name, $prog1TargetDate, 1, $prog1ForceDayOfWeek, false).$lineBr;
        if($prog1Name == "Adventures In Odyssey") {
          $out .= makeMusic(1, "CLD");
        }
        else {
          $out .= makeMusic(1, "WIN");
        }
        $out .= "Play ".scheduleProg($prog1Name, $prog1TargetDate, 2, $prog1ForceDayOfWeek, false).$lineBr;
        if($prog1Name == "Adventures In Odyssey") {
          $out .= makeMusic(1, "CLD");
        }
        else {
          $out .= makeMusic(1, "WIN");
        }
        $out .= "Play ".scheduleProg($prog1Name, $prog1TargetDate, 3, $prog1ForceDayOfWeek, $prog1Incr).$lineBr;
      }
    }
    else {
      //not segmented
      if($prog1TargetDate == "PICKRANDOM") {
        $out .= "Play ".pickRandom($programRoot.$prog1Name).$lineBr;
      }
      else {
        $out .= "Play ".scheduleProg($prog1Name, $prog1TargetDate, 0, $prog1ForceDayOfWeek, $prog1Incr).$lineBr;
      }
    }
    $out .= makeProgramIdentification($prog1Name, $hour);
  }
  $out .= makeMusic(1, "WSM"); //one medium song after the programs
  $out .= makeMusic(20, $musicType); //schedule a lot of music for programs that might not exist or are damaged and stop prematurely
  
  if($prog2Name == "" && $prog3Name == "") {
    //no 2nd and 3rd program scheduled
    if($prog1Name == "Bible Answer Man" || $prog1Name == "PMF Message") {
      //exception for programs lasting 45 minutes or longer...
      $out .= "# time-correct@:56:00".$lineBr;
      $out .= makeProgramAnnouncement($hour + 1, $weekday);
      $out .= makeMusic(6, $musicType);
      $out .= makeMusic(3, "WIN"); //instrumental before station ID
    }
    else {
      //for programs that have a normal length...
      $out .= "# time-correct@:30:00".$lineBr;
      $out .= makeStationID($hour, $weekday, false).$lineBr;
      $out .= makeMusic(8, $musicType);
      $out .= "# time-correct@:45:00".$lineBr;
      $out .= makeProgramAnnouncement($hour + 1, $weekday);
      $out .= makeMusic(6, $musicType);
      $out .= "# time-correct@:57:00".$lineBr; //instrumental before station ID
      $out .= makeMusic(3, "WIN");
    }
  }
  
  if($prog2Name != "" && $prog3Name == "") {
    //2nd program scheduled, no 3rd program scheduled
    $out .= "# time-correct@:36:00".$lineBr;
    $out .= makeStationID($hour, $weekday, false).$lineBr;
    if($prog2TargetDate == "PICKRANDOM") {
      $out .= "Play ".pickRandom($programRoot.$prog2Name).$lineBr;
    }
    else {
      $out .= "Play ".scheduleProg($prog2Name, $prog2TargetDate, 0, $prog2ForceDayOfWeek, $prog2Incr).$lineBr;
    }
    $out .= makeMusic(2, $musicType);
    $out .= makeProgramAnnouncement($hour + 1, $weekday);
    $out .= makeMusic(10, $musicType);
    $out .= "# time-correct@:57:00".$lineBr; //instrumental before station ID
    $out .= makeMusic(3, "WIN");
  }
  
  if($prog2Name == "" && $prog3Name != "") {
    //3rd program scheduled, no 2nd program scheduled
    $out .= "# time-correct@:48:00".$lineBr;
    //$out .= makeStationID($hour, $weekday, false).$lineBr;
    if($prog3TargetDate == "PICKRANDOM") {
      $out .= "Play ".pickRandom($programRoot.$prog3Name).$lineBr;
    }
    else {
      $out .= "Play ".scheduleProg($prog3Name, $prog3TargetDate, 0, $prog3ForceDayOfWeek, $prog3Incr).$lineBr;
    }
    //$out .= makeMusic(1, $musicType);
    $out .= makeProgramAnnouncement($hour + 1, $weekday);
    $out .= makeMusic(10, $musicType);
    $out .= "# time-correct@:57:00".$lineBr; //instrumental before station ID
    $out .= makeMusic(3, "WIN");
  }
  
  if($prog2Name != "" && $prog3Name != "") {
    //2nd and 3rd program scheduled
    $out .= "# time-correct@:36:00".$lineBr;
    $out .= makeStationID($hour, $weekday, false).$lineBr;
    if($prog2TargetDate == "PICKRANDOM") {
      $out .= "Play ".pickRandom($programRoot.$prog2Name).$lineBr;
    }
    else {
      $out .= "Play ".scheduleProg($prog2Name, $prog2TargetDate, 0, $prog2ForceDayOfWeek, $prog2Incr).$lineBr;
    }
    $out .= makeMusic(10, $musicType);
    $out .= "# time-correct@:48:00".$lineBr;
    if($prog3TargetDate == "PICKRANDOM") {
      $out .= "Play ".pickRandom($programRoot.$prog3Name).$lineBr;
    }
    else {
      $out .= "Play ".scheduleProg($prog3Name, $prog3TargetDate, 0, $prog3ForceDayOfWeek, $prog3Incr).$lineBr;
    }
    //$out .= makeMusic(1, $musicType);
    $out .= makeProgramAnnouncement($hour + 1, $weekday);
    $out .= makeMusic(8, $musicType);
    $out .= "# time-correct@:57:00".$lineBr; //instrumental before station ID
    $out .= makeMusic(3, "WIN");
  }
  
  return $out;
}


function makeMyClipHour($hour, $musicType, $weekday, $clipTempo) {
  global $lineBr;
  global $programRoot;
  global $voiceRoot;
  global $interrupt_fadeout;
  
  if($clipTempo != "Slow" && $clipTempo != "Fast") {
    logError("Clip Tempo invalid: ".$clipTempo);
  }
  
  $out = "";
  $out .= "# Hour ".$hour.$lineBr;
  $out .= "# interrupt@:00:00 ".$interrupt_fadeout.$lineBr;
  $out .= makeStationID($hour, $weekday, true).$lineBr;
  $out .= makePublicAnnouncements();
  $out .= makeTTCommands($hour);
  
  for($i = 0; $i < 12; $i++) {
    $out .= makeMusic(1, $musicType);
    if($clipTempo == "Slow") {
      $out .= "Play ".pickRandom($programRoot.pickSlowClip()).$lineBr;
    }
    else {
      $out .= "Play ".pickRandom($programRoot.pickFastClip()).$lineBr;
    }
  }
  
  $out .= "# time-correct@:30:00".$lineBr;
  $out .= makeStationID($hour, $weekday, false).$lineBr;
  
  for($i = 0; $i < 7; $i++) {
    $out .= makeMusic(1, $musicType);
    if($clipTempo == "Slow") {
      $out .= "Play ".pickRandom($programRoot.pickSlowClip()).$lineBr;
    }
    else {
      $out .= "Play ".pickRandom($programRoot.pickFastClip()).$lineBr;
    }
  }

  $out .= "# time-correct@:45:00".$lineBr;
  $out .= makeMusic(1, $musicType);
  $out .= makeProgramAnnouncement($hour + 1, $weekday);
  
  for($i = 0; $i < 5; $i++) {
    $out .= makeMusic(1, $musicType);
    if($clipTempo == "Slow") {
      $out .= "Play ".pickRandom($programRoot.pickSlowClip()).$lineBr;
    }
    else {
      $out .= "Play ".pickRandom($programRoot.pickFastClip()).$lineBr;
    }
  }

  $out .= "# time-correct@:57:00".$lineBr;
  $out .= makeMusic(3, "WIN"); //instrumental before station ID
  return $out;
}


function makeMyPlainHour($hour, $musicType, $weekday) {
  global $lineBr;
  global $voiceRoot;
  global $interrupt_fadeout;
  $out = "";
  $out .= "# Hour ".$hour.$lineBr;
  $out .= "# interrupt@:00:00 ".$interrupt_fadeout.$lineBr;
  $out .= makeStationID($hour, $weekday, true).$lineBr;
  $out .= makePublicAnnouncements();
  $out .= makeTTCommands($hour);
  $out .= makeMusic(15, $musicType);
  $out .= "# time-correct@:30:00".$lineBr;
  $out .= makeStationID($hour, $weekday, false).$lineBr;
  $out .= makeMusic(3, $musicType);
  $out .= makeProgramAnnouncement($hour + 1, $weekday);
  $out .= makeMusic(12, $musicType);
  $out .= "# time-correct@:57:00".$lineBr; //instrumental before station ID
  $out .= makeMusic(3, "WIN");
  return $out;
}


//PMF Message broadcast on Sunday (same day) cannot be scheduled by scheduleProg() because they
//are not yet available on Saturday, 22:00.
function makeMyPMFMessageSunHour($hour, $musicType, $weekday, $sundayDate) {
  global $lineBr;
  global $voiceRoot;
  global $programRoot;
  global $interrupt_fadeout;
  $hourWithLeadingZero = addHourLeadingZero($hour);
  $out .= "# Hour ".$hour.$lineBr;
  $out .= "# interrupt@:00:00 ".$interrupt_fadeout.$lineBr;
  $out .= makeStationID($hour, $weekday, true).$lineBr;
  $out .= makeTTCommands($hour);
  $out .= "Play ".$programRoot."PMF Message/".$sundayDate.".mp3".$lineBr;
  //don't make program identification because message might not be available...
  $out .= makeMusic(15, $musicType);
  $out .= "# time-correct@:30:00".$lineBr;
  $out .= makeStationID($hour, $weekday, false).$lineBr;
  $out .= "# time-correct@:40:00".$lineBr; //jump over StationID if message is playing
  $out .= makeMusic(15, $musicType).$lineBr;
  $out .= "# time-correct@:57:00".$lineBr; //instrumental before station ID
  $out .= makeMusic(3, "WIN");
  return $out;
}


//PMF Message broadcast on Weekdays cannot be scheduled by scheduleProg() because if the
//message is not available, a short program hour should play instead of repeating old messages.
function makeMyPMFMessageWDHour($hour, $musicType, $weekday, $targetDate) {
  global $lineBr;
  global $programRoot;
  $out = "";
  if(file_exists($programRoot."PMF Message/".lastSunday($targetDate).".mp3")) {
    $out .= makeMyProgramHour($hour, "STD", $targetWeekday, "PMF Message",           lastSunday($targetDate), false, true,  true,  "",                           "PICKRANDOM", false, true,  "",                              "PICKRANDOM", false, true).$lineBr;
  }
  else {
    $out .= makeMyClipHour($hour, $musicType, $weekday, "Fast");
  }
  return $out;
}


function makeStationID($hour, $weekday, $timeAnnounce) {
  global $lineBr;
  global $voiceRoot;
  $hourWithLeadingZero = addHourLeadingZero($hour);
  $myFolder = "";
  
  if($timeAnnounce) {
    $myFolder = $voiceRoot."StationID_".$hourWithLeadingZero."00";
  }
  else {
    if($hour == 8 || $hour == 12 || $hour == 18) {
      $myFolder = $voiceRoot."StationID_V6MA";
    }
    if($hour == 15 || $hour == 21 || $weekday == "Saturday") {
      //play PMF invitation Mon-Fri at 1500 and 2100 and all the time on Saturdays
      $myFolder = $voiceRoot."StationID_PMFChurchInvitation";
    }
    if(($hour == 6 || $hour == 7 || $hour == 8 || $hour == 9) && $weekday == "Sunday") {
      //play PMF invitation on Sunday mornings
      $myFolder = $voiceRoot."StationID_PMFChurchInvitation";
    }
    if(($hour == 5 || $hour == 6) && $weekday != "Saturday" && $weekday != "Sunday") {
      $myFolder = $voiceRoot."StationID_EarlyMorning";
    }
    if(($hour == 9 || $hour == 10) && $weekday != "Saturday" && $weekday != "Sunday") {
      $myFolder = $voiceRoot."StationID_LateMorning";
    }
    if(($hour == 13 || $hour == 14) && $weekday != "Saturday" && $weekday != "Sunday") {
      $myFolder = $voiceRoot."StationID_EarlyAfternoon";
    }
    if(($hour == 16 || $hour == 17) && $weekday != "Saturday" && $weekday != "Sunday") {
      $myFolder = $voiceRoot."StationID_LateAfternoon";
    }
    if(($hour == 19 || $hour == 20) && $weekday != "Saturday" && $weekday != "Sunday") {
      $myFolder = $voiceRoot."StationID_EarlyEvening";
    }
    if($hour == 23) {
      $myFolder = $voiceRoot."StationID_LateEvening";
    }
  }
  
  if($myFolder == "" || !filesAvailableInFolder($myFolder)) {
    $myFolder = $voiceRoot."StationID";
  }
  
  return "Play ".pickRandom($myFolder);
}


function makePublicAnnouncements() {
  global $lineBr;
  global $voiceRoot;
  $out = "";
  $myFolderHandle = opendir($voiceRoot."Announcements");
  while(false !== ($myFile = readdir($myFolderHandle))) {
    if($myFile."" != "." && $myFile."" != "..") {
      if(substr($myFile, 0, 1) == "_") {
        //do not play if the file name starts with an underscore
        //those files are temporarily not used (for instance for voice files that are temp. suspended)
      }
      else {
        $out .= "Play ".$voiceRoot."Announcements/".$myFile.$lineBr;
      }
    }
  }
  return $out;
}


function makeProgramAnnouncement($hour, $weekday) {
  global $lineBr;
  global $voiceRoot;
  global $programRoot;
  global $globalTargetDate;
  $out = "";
  $dow = ""; //day of week (WD, SAT or SUN)
  switch($weekday) {
    case "Saturday":
      $dow = "SAT";
      break;
    case "Sunday":
      $dow = "SUN";
      break;
    default:
      $dow = "WD";
  }
  
  //Exception: do not play PAN for PMF Message if message is not available...
  if($hour == "22") {
    if(!file_exists($programRoot."PMF Message/".lastSunday($globalTargetDate).".mp3")) {
      //PMF Message doesn't exist: do not play PAN
      return "";
    }
  }
  
  $hourWithLeadingZero = addHourLeadingZero($hour);
  $myFolder = $voiceRoot."PAN_".$dow."_".$hourWithLeadingZero."00";
  $myAnnouncement = "";
  
  //it would work to just invoke pickRandom(), but produce a log error if no file available
  //since makeProgramAnnouncement() is invoked every single hour (even hours with no program available)
  //and I don't want all those errors in my logs, so: check first before invoking pickRandom()
  //check if files are available in folder
  if(filesAvailableInFolder($myFolder)) {
    //at least 1 audio file is available
    $myAnnouncement = pickRandom($myFolder);
    $out .= "Play ".$myAnnouncement.$lineBr;
  }
  return $out;
}


function makeProgramIdentification($programName, $hour) {
  global $lineBr;
  global $voiceRoot;
  $out = "";
  $myFolder = $voiceRoot."PID_".$programName;
  $myAnnouncement = "";
  
  //Override for exceptions
  if($programName == "Walk In The Word" && $hour == 6) {
    $myFolder = $voiceRoot."PID_Exceptions/PID_Walk In The Word_Repeat";
  }
  if($programName == "A New Beginning" && $hour == 11) {
    $myFolder = $voiceRoot."PID_Exceptions/PID_A New Beginning_Repeat";
  }
  if($programName == "Insight For Living" && $hour == 12) {
    $myFolder = $voiceRoot."PID_Exceptions/PID_Insight For Living_Repeat";
  }
  
  //it would work to just invoke pickRandom(), but produce a log error if no file available
  //since makeProgramAnnouncement() is invoked every single hour (even hours with no program available)
  //and I don't want all those errors in my logs, so: check first before invoking pickRandom()
  //check if files are available in folder
  if(filesAvailableInFolder($myFolder)) {
    //at least 1 audio file is available
    $myAnnouncement = pickRandom($myFolder);
    $out .= "Play ".$myAnnouncement.$lineBr;
  }
  return $out;
}


/*
 * $programName:    "Insight For Living"
 * $targetDate:     "2007-06-30"
 * $segment:        0: no segmentation, 1-3: segment 1-3
 * $forceDayOfWeek: true to force
 * $increment:      false to not write the new program date to file (program date will be the same next time)
 */
function scheduleProg($programName, $targetDate, $segment, $forceDayOfWeek, $increment) {
  global $programRoot;
  logFile("Scheduling ".$programName." for target date: ".$targetDate);
  $myFolder = $programRoot.$programName;
  if(!file_exists($myFolder)) {
    logError("PROGRAM FOLDER DOES NOT EXIST: ".$myFolder);
    return "";
  }
  
  $targetDateArr = explode("-", $targetDate);
  $targetDateVar = getdate(mktime(0, 0, 0, $targetDateArr[1], $targetDateArr[2], $targetDateArr[0])); 
  $targetDayOfWeek = $targetDateVar[weekday];
  
  //create array of all mp3 files for this program
  $audioFiles = array();
  $myFolderHandle = opendir($myFolder) or die("can't open folder: ".$myFolder);
  while(false !== ($myFile = readdir($myFolderHandle))) {
    if($myFile != "." && $myFile != "..") {
      array_push($audioFiles, $myFile);
    }
  }
  closedir($myFolderHandle);
  
  if(count($audioFiles) == 0) {
    logError("PROGRAM FOLDER IS EMPTY: ".$myFolder);
    return "";
  }
  
  logDetail("files available: ".count($audioFiles));
  natcasesort($audioFiles);
  
  //check if todays program is available
  $keyToday = searchProgram($targetDate, $audioFiles);
  
  if($keyToday == -1) {
    //todays program is not available: use old program date
    
    //read yesterdays program date from file
    $programYesterday = readProgramHistory($programName);
    if($programYesterday == "NO DATA") {
      logDetail("yesterday data not available");
      $keyToday = 0;
    }
    else {
      $keyYesterday = searchProgram($programYesterday, $audioFiles);
      logDetail("yesterday data available: ".$programYesterday.", key found: ".$keyYesterday);
      if($keyYesterday == -1) {
        //file that was played yesterday is not available anymore in file system
        $keyToday = 0; //start from top again
      }
      else {
        //file that was played yesterday was found
        $keyToday = $keyYesterday + 1; //go to next file in file system list
      }
    }
    
    //test if that file was the last one in the list (wrap around)
    if(trim($audioFiles[$keyToday]) == "") {
      logDetail("wrap around to the first file available");
      $keyToday = 0;
    }
    
    logDetail("key today: ".$keyToday.", keyed file: ".$audioFiles[$keyToday]);
    
    //test if day of the week has to match
    if($forceDayOfWeek) {
      logDetail("trying to match target day of the week: ".$targetDayOfWeek);
      $counter = 0;
      $keyTestMatch = $keyToday;
      while($counter < count($audioFiles) && !dayOfWeekMatch($targetDayOfWeek, cutFileExtension($audioFiles[$keyTestMatch]))) {
        $counter++;
        $keyTestMatch++;
        if($keyTestMatch >= count($audioFiles)) {
          $keyTestMatch = 0; //wrap around
        }
      }
      if(count($audioFiles) > 0 && dayOfWeekMatch($targetDayOfWeek, cutFileExtension($audioFiles[$keyTestMatch]))) {
        //matching day of the week was found
        logDetail("old key was: ".$keyToday.", matching key found: ".$keyTestMatch." after ".$counter." iterations");
        $keyToday = $keyTestMatch;
      }
      else {
        //matching day of the week was not found...
        logDetail("match was not found; keeping the old key");
        //keep the old key...
      }
    }
  } //end: use old program date
  else {
    //target date program is availalbe
    logDetail("target date program is available");
  }
  
  //write keyed date and day of the week to show text file
  $tmpKeyedDate = cutFileExtension($audioFiles[$keyToday]);
  $tmpArr = explode("-", $tmpKeyedDate);
  $tmpYear = $tmpArr[0];
  $tmpMonth = $tmpArr[1];
  $tmpDay = $tmpArr[2];
  $tmpKeyedDateVar = getdate(mktime(0, 0, 0, $tmpMonth, $tmpDay, $tmpYear)); 
  logShow($tmpKeyedDate.", ".substr($tmpKeyedDateVar[weekday], 0, 3).": ".$programName);
  
  if($increment) {
    writeProgramHistory($programName, cutFileExtension($audioFiles[$keyToday]));
  }
  else {
    //increment is false when the same progam will be used again later during the same day (repeated)
    //don't write program history to file
  }
  if($segment > 0) {
    $segmentedFolder = $programRoot.$programName."/".$audioFiles[$keyToday];
    $segmentedFiles = array();
    $mySegFolderHandle = opendir($segmentedFolder) or die("can't open folder: ".$segmentedFolder);
    while(false !== ($mySegFile = readdir($mySegFolderHandle))) {
      if($mySegFile != "." && $mySegFile != "..") {
        array_push($segmentedFiles, $mySegFile);
      }
    }
    closedir($mySegFolderHandle);
    natcasesort($segmentedFiles);
    return $programRoot.$programName."/".$audioFiles[$keyToday]."/".$segmentedFiles[$segment - 1];
  }
  else {
    return $programRoot.$programName."/".$audioFiles[$keyToday];
  }
}


function pickRandom($myFolder) {
  if(!file_exists($myFolder)) {
    logError("PICK RANDOM: FOLDER DOES NOT EXIST: ".$myFolder);
    return "";
  }
  $audioFiles = array();
  $myFolderHandle = opendir($myFolder);
  while(false !== ($myFile = readdir($myFolderHandle))) {
    if($myFile."" != "." && $myFile."" != "..") {
      if(substr($myFile, 0, 1) == "_") {
        //do not push file into array if the file name starts with an underscore
        //those files are temporarily not used (for instance for voice files that are temp. suspended)
      }
      else {
        array_push($audioFiles, $myFile);
      }
    }
  }
  
  if(count($audioFiles) == 0) {
    logError("ERROR: FOLDER IS EMPTY: ".$myFolder);
    //An empty folder has to report an error, because otherwise the Master Log will have lines like this:
    //Play 
    //The function that invokes pickRandom() therefore has to check first if there are files available or not
    return "";
  }
  
  srand ((double) microtime() * 1000000); //for php 4.0.4 (BeOS)
  return $myFolder."/".$audioFiles[array_rand($audioFiles)];
}


//this function replaces array_search(), which is not yet availalbe on BeOS
//it finds a file and return the key/index, or -1 if the file was not found
//it searches for a match without regarding the file extension (mp3 or mp2)
function searchProgram($fileName, $audioFiles) {
  for($i=0; $i < count($audioFiles); $i++) {
    if(cutFileExtension($audioFiles[$i]) == $fileName) {
      return $i;
    }
  }
  return -1;
}


/*
 * Checks if at least one file is available in a folder
 * Used in combination with pickRandom(), to take sure not to invoke pickRandom() if no files are available
 */
function filesAvailableInFolder($myFolder) {
  if(file_exists($myFolder)) {
    //check if at least 1 file is available
    $audioFiles = array();
    $myFolderHandle = opendir($myFolder);
    while(false !== ($myFile = readdir($myFolderHandle))) {
      if($myFile."" != "." && $myFile."" != "..") {
        array_push($audioFiles, $myFile);
      }
    }
    if(count($audioFiles) > 0) {
      //at least 1 audio file is available
      return true;
    }
    else {
      return false;
    }
  }
  else {
    return false;
  }
}


function lastSunday($myDate) {
  $myDateArr = explode("-", $myDate);
  $myDateTmp = getdate(mktime(0, 0, 0, $myDateArr[1], $myDateArr[2], $myDateArr[0]));
  $i = 1;
  while($myDateTmp[weekday] != "Sunday") {
    $myDateTmp = getdate(mktime(0, 0, 0, $myDateArr[1], $myDateArr[2] - $i, $myDateArr[0]));
    $i++;
  }
  return date("Y-m-d", $myDateTmp[0]);
}


function makeTTCommands($hour) {
  global $lineBr;
  global $voiceRoot;
  global $processingShowTextLog;
  $out = "";
  if($hour == 3) {
    //reboot system to prevent hang-ups of TuneStacker or other software
    //make music first, otherwise 2 announcements (time and reboot) are right after each other
    $out .= makeMusic(1, "WIN");
    $out .= "Play ".$voiceRoot."Maintenance/Reboot.mp3".$lineBr;
    $out .= "# Run shutdown -r &".$lineBr;
  }
  if($hour == 6) {
    //show programs scheduled for target date
    $out .= "# ShowText /boot/TheCross/".$processingShowTextLog.$lineBr;
  }
  if($hour == 21) {
    //run scheduling program for tomorrow (targetDate)
    $out .= "# Run /boot/TheCross/Run_MasterLog &".$lineBr;
  }
  if($hour == 22) {
    //run TuneStacker for tomorrow (targetDate)
    $out .= "# Run /boot/TheCross/Run_TuneStacker &".$lineBr;
  }
  return $out;
}


function addBeApplication($targetDate, $weekday) {
  global $lineBr;
  $myFile = "/boot/TheCross/Run_TuneStacker";
  $myFileHandle = fopen($myFile, 'a') or die("can't open file to append");
  $line = "";
  $line .= "TuneStacker -m /boot/TheCross/TT_MasterLogs/MasterLog_".$targetDate.".txt -p /boot/TheCross/TT_ProgramLogs/".$weekday." -v /boot/Music/ -g Artist 5".$lineBr.$lineBr;
  /* Do not use the ttreload command anymore, because it causese the PMF Message at 2200
   * to repeat, because during that period, ttreload gets invoked.
   * TTreload is not really needed because we reboot at 0300, and rebooting causes
   * TuneTracker to reload anyway.
   * This way, between 0000 and 0300, the wrong Program Log is actually played (the log from a week ago),
   * but that doesn't matter because it is only music programming
   */
  //$line .= "sync".$lineBr.$lineBr;
  //$line .= "sleep 10".$lineBr.$lineBr;
  //$line .= "ttreload".$lineBr.$lineBr;
  //$line .= "sync".$lineBr.$lineBr;
  //$line .= "sleep 10".$lineBr.$lineBr;
  $line .= "exit";
  fwrite($myFileHandle, $line);
  fclose($myFileHandle);
}


function readProgramHistory($programName) {
  global $programHistory;
  $myFile = $programHistory.$programName.".txt";
  if(!file_exists($myFile)) {
    writeProgramHistory($programName, "");
  }
  else {
    if(filesize($myFile) == 0) {
      return "NO DATA";
    }
    else {
      $myFileHandle = fopen($myFile, 'r') or die("can't open file to read");
      $programDate = fread($myFileHandle, filesize($myFile));
      fclose($myFileHandle);
      return $programDate;
    }
  }
}


function writeProgramHistory($programName, $programDate) {
  global $programHistory;
  $myFile = $programHistory.$programName.".txt";
  $myFileHandle = fopen($myFile, 'w') or die("can't open file to write");
  fwrite($myFileHandle, trim($programDate));
  fclose($myFileHandle);
}


function dayOfWeekMatch($dayOfWeek, $testDate) {
  $temp = explode("-", $testDate);
  $year = $temp[0];
  $month = $temp[1];
  $day = $temp[2];
  $dateVar = getdate(mktime(0, 0, 0, $month, $day, $year)); 
  if($dayOfWeek == $dateVar[weekday]) {
    //match
    return true;
  }
  else {
    //no match
    return false;
  }
}


function addHourLeadingZero($hour) {
  if(strlen($hour) == 1) {
    $hourWithLeadingZero = "0".$hour;
  }
  else {
    $hourWithLeadingZero = $hour;
  }
  return $hourWithLeadingZero;
}


function arrayMultiPush(&$array, $multi, $value) {
  for($i = 0; $i < $multi; $i++) {
    array_push($array, $value);
  }
}


function cutFileExtension($file) {
  $temp = explode(".", $file);
  return $temp[0];
}


function logFile($text) {
  global $lineBr;
  $text = $text.$lineBr;
  $myFile = "PHP_Logs/logPHP_".date("Y-m-d").".txt";
  $myFileHandle = fopen($myFile, "a") or die("can't open log file to append");
  fwrite($myFileHandle, $text);
  fclose($myFileHandle);
}


function logDetail($text) {
  logFile("   -> ".$text);
}


function logError($text) {
  global $numberOfErrors;
  $numberOfErrors++;
  logFile("***** ERROR: ".$text);
}


function logShow($text) {
  global $lineBr;
  global $processingShowTextLog;
  $text = $text.$lineBr;
  $mySTFileHandle = fopen($processingShowTextLog, "a") or die("can't open showtext file to append");
  fwrite($mySTFileHandle, $text);
  fclose($mySTFileHandle);
}

?>